<?php
//ini_set("memory_limit","512M");

$basedir=dirname(__FILE__);

include_once($basedir . '/../include/config.php');

isset($GLOBALS['CONFIG']) or die("FATAL: " . __FILE__ . ":" . __LINE__. ": config parsing failed\n");

// fighting against duplicate stop names and aggregating their data.
$stops = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/stops_list.txt');
$stops = json_decode($stops, $assoc=true);

$duplicates = array();
for ($i = 0; $i < count($stops); $i++)
{
   $dup_run = array();
   for ($j = $i+1; $j < count($stops); $j++)
   {
      if ($stops[$i]['stop_name'] == $stops[$j]['stop_name'])
      {
         if (count($dup_run) == 0)
            $dup_run[] = $stops[$i]['stop_id'];
         $dup_run[] = $stops[$j]['stop_id'];
         $i++; 
      }
      
   }
   
   if (count($dup_run) > 0)
      $duplicates[] = $dup_run;
}

$skip_stops = array();
foreach ($duplicates as $entry)
{
   $compile_to = json_decode(file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $entry[0] . '.txt'), $assoc=true);

   $agg_lines = array();
   foreach ($entry as $stop)
   {
      $file = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $stop . '.txt');
      $lines = json_decode($file, $assoc=true);
      if (!isset($lines['lines']) || $lines['lines'] == null)
         continue;

      $agg_lines = array_merge($agg_lines, $lines['lines']);
   }

   for ($i = 1; $i < count($entry); $i++)
   {
      $skip_stops[] = $entry[$i];
   } 

   $compile_to['lines'] = $agg_lines;
 
   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $entry[0] . '.txt', 'w');
   fwrite($file, json_encode($compile_to));
   chmod($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $entry[0] . '.txt', 0644);
   fclose($file);
}
$routes = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/route_config.txt');
$routes = json_decode($routes, $assoc=true);

$combined_string = '[';

for ($i = 0; $i < count($routes); $i++)
{
   $route_content = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $routes[$i]['route_id'] . '.txt'); 
   $combined_string .= $route_content;
   $combined_string .= ',';
}

$combined_string = substr_replace($combined_string, "", -1);
$combined_string .= ']';

$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/times.txt','w');
fwrite($file, $combined_string);
chmod($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/times.txt', 0644);
fclose($file);

$combined_string = '[';
for ($i = 0; $i < count($stops); $i++)
{
   if (in_array($stops[$i]['stop_id'], $skip_stops))
   {
      $stop_content = '{"running":false}';
   }
   else
   {
      $stop_content = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $stops[$i]['stop_id'] . '.txt');
   }
   
   $combined_string .= $stop_content;
   $combined_string .= ',';
}

$combined_string = substr_replace($combined_string, "", -1);
$combined_string .= ']';

$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/stop_times.txt', 'w');
fwrite($file, $combined_string);
chmod($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/stop_times.txt', 0644);
fclose($file);

chmod($GLOBALS['CONFIG']['temp_dir'] . '/nextbus', 0755);

// create destdir if needed
if (!is_dir($GLOBALS['CONFIG']['web_dir'] . '/nextbus')) {
  mkdir($GLOBALS['CONFIG']['web_dir'] . '/nextbus', 0755) or die("Couldn't create " . $GLOBALS['CONFIG']['web_dir'] . "/nextbus/");
}

// I'm going to let the shell glob this, for right or (more likely) for wrong...
// DEFINITE downside: if any files go stale, they never get rm'd
// however we CANNOT rename() the filled directory because that's TWO mv() operations
$output = system('mv ' . $GLOBALS['CONFIG']['temp_dir'] . '/nextbus/* ' . $GLOBALS['CONFIG']['web_dir'] . '/nextbus/', $retval);
if ($retval) die("error during mv, " . $output);
?>
